#ifndef _LIC_H_
#define _LIC_H_

//#include <crtdbg.h>

#include <time.h>
#include <float.h>
#include <math.h>
#define min(a,b) (((a) < (b)) ? (a) : (b))

#include "field2d.h"
#include "vector3d.h"
#include "exception.h"

using namespace std;


typedef Field2D<Vector3D> T_VectorField;
//typedef T_VectorField::iterator IT_VectorField;
typedef Field2D<unsigned char> T_CharField;
//typedef T_CharField::iterator IT_CharField;
typedef vector<Vector3D> T_StreamLine;
typedef vector<T_StreamLine> T_StreamLines;
typedef Field2D<int> T_BoolField;
typedef Field2D<float> T_FloatField;

class LIC
{
public:
	void LoadImage( const char* FileName );
	void LoadImage( const T_CharField& Image );
	void GenImage();
	void LoadVectorField( const char* FileName );
	void LoadVectorField( const T_VectorField& VectorField );
	void SaveResult( const char* FileName );

	void DoLIC( int L );
	void DoDDA( int L );

	void AdjustContrast();

	inline int GetWidth() const
	{
		return m_Width;
	}

	inline int GetHeight() const
	{
		return m_Height;
	}

private:

	void AddStreamLine( T_StreamLine& S, float DSep, int i, int j );
	float ComputeCurve( int x, int y, int L );

	int				m_Width;
	int				m_Height;

	T_CharField		m_ImageIn;
	T_CharField		m_ImageOut;
	T_VectorField	m_VectorField;
	T_FloatField	m_Curve;
};



#endif //_LIC_H_
