
#include "vector3d.h"


Vector3D::Vector3D()
:	m_x( 0 ), m_y( 0 ), m_z( 0 )
{}

Vector3D::Vector3D( float x, float y, float z )
:	m_x( x ), m_y( y ), m_z( z )
{}


Vector3D& Vector3D::operator += ( const Vector3D& V )
{
	m_x += V.m_x;
	m_y += V.m_y;
	m_z += V.m_z;

	return( *this );
}

Vector3D& Vector3D::operator -= ( const Vector3D& V )
{
	m_x -= V.m_x;
	m_y -= V.m_y;
	m_z -= V.m_z;

	return( *this );
}

Vector3D Vector3D::operator + ( const Vector3D& V ) const
{
	return Vector3D( m_x + V.m_x, m_y + V.m_y, m_z + V.m_z );
}

Vector3D Vector3D::operator - ( const Vector3D& V ) const
{
	return Vector3D( m_x - V.m_x, m_y - V.m_y, m_z - V.m_z );
}

float Vector3D::operator * ( const Vector3D& V ) const
{
	return m_x * V.m_x + m_y * V.m_y + m_z * V.m_z;
}

Vector3D Vector3D::operator ^ ( const Vector3D& V ) const
{
	return Vector3D( m_y * V.m_z - m_z * V.m_y,
					 m_z * V.m_x - m_x * V.m_z,
					 m_x * V.m_y - m_y * V.m_x );
}

Vector3D Vector3D::operator * ( float S ) const
{
	return Vector3D( m_x * S, m_y * S, m_z * S );
}
Vector3D Vector3D::operator / ( float S ) const
{
	return Vector3D( m_x / S, m_y / S, m_z / S );
}

Vector3D& Vector3D::operator *= ( float S )
{
	m_x *= S;
	m_y *= S;
	m_z *= S;

	return( *this );
}

Vector3D& Vector3D::operator /= ( float S )
{
	m_x /= S;
	m_y /= S;
	m_z /= S;

	return( *this );
}
